#! /usr/local/bin/perl


####################################################
#  Formalur                                        #
#                                                  #
#  Ein Programm zum Versenden eines Formular-      #
#  Inhalts per E-Mail                              #
#  Autor: Oliver Hellberg                          #
#  http://www.olli.net                             #
#  E-Mail: olli@olli.net                           #
#                                                  #
#  Der Autor bernimmmt keine Haftung fr irgend-  #
#  welche Schden, die dadurch entstehen, da das  #
#  Programm nicht das macht, was es soll, es       #
#  falsch macht oder was auch immer nicht oder     #
#  doch macht. Er bernimmt einfach gar keine      #
#  Haftung.                                        #
#                                                  #                                        
#  Der Autor wrde sich freuen ber Feedback der   #  
#  Benutzer (Verbesserungsvorschlge, Einsatzort,  #
#  insbesondere aber Lob).                         #
#                                                  #
#  Diese Bemerkungen (Kstchen) drfen nicht aus   #
#  dem Programm entfernt bzw. verndert werden.    #
#                                                  #
####################################################


# Ehe Sie anfangen, an den Einstellungen rumzumachen: Dieses Programm
# luft nur unter UNIX. Unter Windows werden Sie keinen grossen Spa
# haben am Formalur.



require "./user.dat";

$| = 1;

%formular = ordne_daten();

for (keys %formular) {
	$mailtext .= "$_ : $formular{$_}\n";
}

$mailtext = $mailtextanfang . $mailtext . $mailtextanhang;

print "Location: $bestaetigungsseite\n\n";

&versende_post($absender, $admin, $thema, $mailtext);

exit;

sub ordne_daten  {
   local ($request_method, $query_string, @paare, $schluessel, $wert);
   $request_method = $ENV{'REQUEST_METHOD'};
   if ($request_method eq "GET")  {
		$query_string = $ENV{'QUERY_STRING'};
	}
	elsif ($request_method eq "POST")  {
		read (STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
	}
	else {
      $daten{olli_telnet} = 1;
      return %daten;
	}
   @paare = split (/&/, $query_string);
   for (@paare)  {
		($schluessel, $wert) = split (/=/, $_);
		$wert =~ s/\+/ /gs;
		$wert =~ s/%(\w\w)/chr hex $1/gse;
		$wert =~ s/\a|\f|\e|;|`//g;
		$wert =~ s/</&lt;/g;
		$wert =~ s/>/&gt;/g;
		if (defined $daten{$schluessel})  {
			$daten{$schluessel} = join ("___", $daten{$schluessel}, $wert);
		}
		else  { $daten{$schluessel} = $wert; }
	}
	return %daten;
}	

 
sub versende_post  {
   my ($from, $an, $subject, $text) = @_;
   open (MAIL, "| $sendmail -n -t -f$from");  
	print MAIL <<Post_Ende;
To: $an
Subject: $subject

$text
Post_Ende

	close (MAIL);
}



